------------------------------------------------------------------------------
--
-- Filename:                array_eq.vhd
-- Inhalt:                  Beispiel fuer LOOP-Anweisungen
--                          Vergleich von zwei 9x9-Matrizen
--                          equal wird true, falls alle Werte gleich sind
--
------------------------------------------------------------------------------
--
-- Autor:                   Bernhard Wunder 
-- Letzte Aenderung:        03.02.94
--
------------------------------------------------------------------------------

PACKAGE array_pack IS

  TYPE bit_matrix IS ARRAY (integer RANGE <>, integer RANGE <>) OF bit ;

END array_pack ;

------------------------------------------------------------------------------

ENTITY array_compare IS

  PORT (a, b  : IN  work.array_pack.bit_matrix(8 DOWNTO 0, 8 DOWNTO 0) ;
        equal : OUT boolean) ;
   
END array_compare ;

------------------------------------------------------------------------------

ARCHITECTURE behavioral OF array_compare IS

BEGIN

  cmp : PROCESS (a,b)

    VARIABLE equ : boolean ;

  BEGIN

    equ := true ;

    first_dim_loop : FOR k IN a'RANGE(1) LOOP
      second_dim_loop : FOR l IN a'RANGE(2) LOOP
        IF a(k,l) /= b(k,l) THEN
          equ := false ;
          EXIT first_dim_loop ;          -- Ausstieg falls ungleiche Elemente
        END IF ;
      END LOOP ;
    END LOOP ;

    equal <= equ ;

  END PROCESS ;

END behavioral ;

