------------------------------------------------------------------------------
--
-- Filename:                overload.vhd
-- Inhalt:                  Beispiel zur Ueberladung von Funktionen
--                          Vier Varianten der Funktion max zur 
--                          Bestimmung des Maximalwertes
--
------------------------------------------------------------------------------
--
-- Autor:                   Gunther Lehmann 
-- Letzte Aenderung:        06.03.94
--
------------------------------------------------------------------------------

ENTITY overload IS

  -- Bestimmung des Maximums von zwei integer-Werten
  FUNCTION max (a_i, b_i : integer) RETURN integer IS
  BEGIN
    IF a_i >= b_i THEN return a_i;
    ELSE               return b_i;
    END IF;
  END max;

  -- Bestimmung des Maximums von drei integer-Werten
  FUNCTION max (a_i, b_i, c_i : integer) RETURN integer IS
  BEGIN
    IF    a_i >= b_i AND a_i >= c_i THEN return a_i;
    ELSIF b_i >= a_i AND b_i >= c_i THEN return b_i;
    ELSE                                 return c_i;
    END IF;
  END max;

  -- Bestimmung des Maximums von zwei real-Werten
  FUNCTION max (a_r, b_r : real) RETURN real IS
  BEGIN
    IF a_r >= b_r THEN return a_r;
    ELSE               return b_r;
    END IF;
  END max;
  
  -- Bestimmung des Maximums von drei real-Werten
  FUNCTION max (a_r, b_r, c_r : real) RETURN real IS
  BEGIN
    IF    a_r >= b_r AND a_r >= c_r THEN return a_r;
    ELSIF b_r >= a_r AND b_r >= c_r THEN return b_r;
    ELSE                                 return c_r;
    END IF;
  END max;
  
END overload;


---------------------------------------------------------------------

-- Anwendung der mehrfach ueberladenen Funktion max aus der Entity

ARCHITECTURE behavioral OF overload IS
BEGIN

  PROCESS

    VARIABLE a, d : real := 0.0;
    VARIABLE b, c : integer := 0;

  BEGIN

    a := max(3.2, 2.1);           -- 3. Variante von max, a = 3.2
    b := max(1, 2, 3);            -- 2. Variante von max, b = 3
    c := max(0, 9);               -- 1. Variante von max, c = 9
    d := max(real(6), 4.3, 2.1);  -- 4. Variante von max, d = 6.0 
    WAIT;

  END PROCESS;

END behavioral;

---------------------------------------------------------------------

