------------------------------------------------------------------------------
--
-- Filename:            dff.vhd
-- Inhalt:              Verschiedene Modellierungsalternativen 
--                      eines D-Flip-Flops
--
------------------------------------------------------------------------------
--
-- Autor:               Manfred Selz
-- Letzte Aenderung:    16.02.1994
--
------------------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.all;

------------------------------------------------------------------------------

ENTITY dff IS

  PORT (clk,d: IN  std_ulogic;
        q:     OUT std_ulogic );

END dff;

------------------------------------------------------------------------------

ARCHITECTURE variante1 OF dff IS

BEGIN

  PROCESS
  BEGIN

    WAIT UNTIL clk'EVENT AND clk='1';
    q <= d;

  END PROCESS;

END variante1;

------------------------------------------------------------------------------

ARCHITECTURE variante2 OF dff IS

BEGIN

  PROCESS (clk)
  BEGIN

    IF (clk'EVENT AND clk='1') THEN
      q <= d;
    END IF;

  END PROCESS;

END variante2;

------------------------------------------------------------------------------

ARCHITECTURE variante3 OF dff IS

BEGIN

  PROCESS
  BEGIN

    -- Attribut LAST_VALUE wird nicht von allen Synthesewerkzeugen akzeptiert
    WAIT UNTIL clk'EVENT AND clk='1' AND clk'LAST_VALUE='0';
    q <= d;

  END PROCESS;

END variante3;

------------------------------------------------------------------------------

ARCHITECTURE variante4 OF dff IS

BEGIN

  PROCESS (clk)
  BEGIN

    -- Attribut LAST_VALUE wird nicht von allen Synthesewerkzeugen akzeptiert
    IF (clk'EVENT AND clk='1' AND clk'LAST_VALUE='0') THEN
      q <= d;
    END IF;

  END PROCESS;

END variante4;
