------------------------------------------------------------------------------
--
-- Filename:                and2.vhd
-- Inhalt:                  Zeitabhaengiges Modell eines AND2-Gatters, welches
--                          die 9-wertige Logik std_logic_1164 verwendet
--
------------------------------------------------------------------------------
--
-- Autor:                   Bernhard Wunder
-- Letzte Aenderung:        18.01.1994
--
------------------------------------------------------------------------------

LIBRARY    ieee;
USE        ieee.std_logic_1164.all;

------------------------------------------------------------------------------

ENTITY and2 IS

    GENERIC (tp_lh: time := 230 ps; 
             tp_hl: time := 170 ps);
    PORT (a,b:  IN  std_ulogic;
          y:    OUT std_ulogic);

END and2;

------------------------------------------------------------------------------

ARCHITECTURE behavioral OF and2 IS

-- Funktion zur Bestimmung des Minimums zweier Zeiten

    FUNCTION min (x, y: time) RETURN time IS
    BEGIN
        IF y < x THEN
            RETURN y;
        END IF;
        RETURN x;
    END min;

BEGIN

-- Berechnung des Ausgangs nach entsprechender Verzoegerung

    y <= '1' AFTER tp_lh WHEN ((a AND b) = '1') ELSE
         '0' AFTER tp_hl WHEN ((a AND b) = '0') ELSE
         'X' AFTER min (tp_lh,tp_hl);

END behavioral;

------------------------------------------------------------------------------

CONFIGURATION and2_config OF and2 IS

    FOR behavioral
    END FOR;

END and2_config;
