------------------------------------------------------------------------------
--
-- Filename:                and2_tb.vhd
-- Inhalt:                  Testbench fuer das AND2-Gatter and2.vhd
--
------------------------------------------------------------------------------
--
-- Autor:                   Bernhard Wunder  
-- Letzte Aenderung:        18.01.1994
--
------------------------------------------------------------------------------

LIBRARY    ieee;
USE        ieee.std_logic_1164.all;

------------------------------------------------------------------------------

ENTITY and2_tb IS

END and2_tb;

------------------------------------------------------------------------------

ARCHITECTURE arch_1 OF and2_tb IS

    SIGNAL a,b,y: std_ulogic;

    COMPONENT and2
        PORT (x1,x2 : IN  std_ulogic; 
              x3    : OUT std_ulogic);
    END COMPONENT;

BEGIN

    model_under_test: and2 PORT MAP (a,b,y);    -- Instanz MUT

    PROCESS
    BEGIN
        a <= '0' AFTER  0 ns,                   -- Stimuli
             '1' AFTER 10 ns,
             'X' AFTER 20 ns,
             '1' AFTER 25 ns;
    
        b <= '0' AFTER  0 ns,  
             '1' AFTER  5 ns,
             '0' AFTER 10 ns,
             '1' AFTER 15 ns,
             '0' AFTER 20 ns,
             'X' AFTER 25 ns;
                                                -- erwartete Antworten: 
                                                -- pruefe 1 ns nach Stimuli

        WAIT FOR  1 ns; ASSERT (y = '0') REPORT "y isn't 0" SEVERITY failure;
        WAIT FOR  5 ns; ASSERT (y = '0') REPORT "y isn't 0" SEVERITY failure;
        WAIT FOR  5 ns; ASSERT (y = '0') REPORT "y isn't 0" SEVERITY failure;
        WAIT FOR  5 ns; ASSERT (y = '1') REPORT "y isn't 1" SEVERITY failure;
        WAIT FOR  5 ns; ASSERT (y = '0') REPORT "y isn't 0" SEVERITY failure;
        WAIT FOR  5 ns; ASSERT (y = 'X') REPORT "y isn't X" SEVERITY failure;

        WAIT;                                   -- Ende der Simulation

    END PROCESS;

END arch_1;

------------------------------------------------------------------------------

CONFIGURATION and2_tb_config OF and2_tb IS

    FOR arch_1
        FOR model_under_test: and2 USE ENTITY work.and2 (behavioral)
            GENERIC MAP (tp_lh=>0.8 ns, tp_hl=> 0.7 ns)
            PORT MAP (a=>x1, b=>x2, y=>x3);
        END FOR;
    END FOR;

END and2_tb_config;
