------------------------------------------------------------------------------
--
-- Filename:                nor3_tb.vhd
-- Inhalt:                  Testbench fuer das NOR3-Gatter nor3.vhd
--
------------------------------------------------------------------------------
--
-- Autor:                   Bernhard Wunder  
-- Letzte Aenderung:        18.01.1994
--
------------------------------------------------------------------------------

LIBRARY    ieee;
USE        ieee.std_logic_1164.all;

------------------------------------------------------------------------------

ENTITY nor3_tb IS

END nor3_tb;

------------------------------------------------------------------------------

ARCHITECTURE arch_1 OF nor3_tb IS

    SIGNAL a,b,c,y: std_ulogic;

    COMPONENT nor3
        PORT (x1,x2,x3 : IN  std_ulogic; 
              x4       : OUT std_ulogic);
    END COMPONENT;

BEGIN

    model_under_test: nor3 PORT MAP (a,b,c,y);  -- Instanz MUT

    PROCESS
    BEGIN
        a <= '0' AFTER  0 ns,                   -- Stimuli
             '1' AFTER 20 ns,
             'X' AFTER 40 ns,
             '1' AFTER 60 ns;
    
        b <= '0' AFTER  0 ns,
             '1' AFTER 10 ns,
             '0' AFTER 20 ns,
             '1' AFTER 30 ns,
             '0' AFTER 40 ns,
             '1' AFTER 50 ns,
             'X' AFTER 60 ns;
    
        c <= '0' AFTER  0 ns,
             '1' AFTER  5 ns,
             '0' AFTER 10 ns,
             '1' AFTER 15 ns,
             '0' AFTER 20 ns,
             'X' AFTER 25 ns,
             '1' AFTER 30 ns;
                                                -- erwartete Antworten: 
                                                -- pruefe 1 ns nach Stimuli

        WAIT FOR  1 ns; ASSERT (y = '1') REPORT "y isn't 1" SEVERITY failure;
        WAIT FOR  5 ns; ASSERT (y = '0') REPORT "y isn't 0" SEVERITY failure;
        WAIT FOR  5 ns; ASSERT (y = '0') REPORT "y isn't 0" SEVERITY failure;
        WAIT FOR  5 ns; ASSERT (y = '0') REPORT "y isn't 0" SEVERITY failure;
        WAIT FOR  5 ns; ASSERT (y = '0') REPORT "y isn't 0" SEVERITY failure;
        WAIT FOR  5 ns; ASSERT (y = '0') REPORT "y isn't 0" SEVERITY failure;
        WAIT FOR  5 ns; ASSERT (y = '0') REPORT "y isn't 0" SEVERITY failure;
        WAIT FOR  5 ns; ASSERT (y = '0') REPORT "y isn't 0" SEVERITY failure;
        WAIT FOR  5 ns; ASSERT (y = '0') REPORT "y isn't 0" SEVERITY failure;
        WAIT FOR  5 ns; ASSERT (y = '0') REPORT "y isn't 0" SEVERITY failure;
        WAIT FOR  5 ns; ASSERT (y = '0') REPORT "y isn't 0" SEVERITY failure;
        WAIT FOR  5 ns; ASSERT (y = '0') REPORT "y isn't 0" SEVERITY failure; 
        WAIT FOR  5 ns; ASSERT (y = '0') REPORT "y isn't 0" SEVERITY failure;

        WAIT;                                 -- Ende der Simulation

    END PROCESS;

END arch_1;

------------------------------------------------------------------------------

CONFIGURATION nor3_tb_config OF nor3_tb IS

    FOR arch_1
        FOR model_under_test: nor3 USE ENTITY work.nor3 (behavioral)
            GENERIC MAP (tp_lh=>0.95 ns, tp_hl=> 0.80 ns)
            PORT MAP (a=>x1, b=>x2, c=>x3, y=>x4);
        END FOR;
    END FOR;

END nor3_tb_config;
