------------------------------------------------------------------------------
--
-- Filename:                bcd_stim.vhd
-- Inhalt:                  Stimuli-Beschreibung fuer die Anzeigesteuerung
--                          Modell erzeugt Testsignale und gibt sie ueber
--                          bcd4 und takt aus
--                          Die Modellantworten (a bis g und stelle1 bis 
--                          stelle4) werden mit ASSERT ueberprueft.
--
------------------------------------------------------------------------------
--
-- Autor:                   Gunther Lehmann
-- Letzte Aenderung:        07.02.94
--
------------------------------------------------------------------------------

USE work.bcd.ALL;

ENTITY bcd_stim IS

	PORT( bcd4:                            OUT inptype;
              takt:                            OUT bit;
              a,b,c,d,e,f,g:                   IN bit;
              stelle1,stelle2,stelle3,stelle4: IN bit);
END bcd_stim;

------------------------------------------------------------------------------

ARCHITECTURE behavioral OF bcd_stim IS
BEGIN
	clock: PROCESS
	BEGIN
		takt <= '0', '1'AFTER 50 ns;
		IF now < 300 ns THEN
		    WAIT FOR 100 ns;	
		ELSE
		    WAIT;
		END IF;
	END PROCESS;	
	
	display: PROCESS 
	BEGIN
		bcd4 <= ( "0001", "0010", "0100" , "1000");
		
		
		WAIT UNTIL stelle2 = '0';
		WAIT FOR 1 ns;
		ASSERT (a,b,c,d,e,f,g) = b"110_110_1"
		REPORT "fehler stelle2: "
		SEVERITY warning;	
		
		WAIT UNTIL stelle3 = '0';
		WAIT FOR 1 ns;
		ASSERT (a,b,c,d,e,f,g) = b"011_001_1"
		REPORT "fehler stelle3: "
		SEVERITY warning;	
		
		WAIT UNTIL stelle4 = '0';
		WAIT FOR 1 ns;
		ASSERT (a,b,c,d,e,f,g) = b"111_111_1"
		REPORT "fehler stelle4: "
		SEVERITY warning;	

		WAIT UNTIL stelle1 = '0';
		WAIT FOR 1 ns;
		ASSERT (a,b,c,d,e,f,g) = b"011_000_0"
		REPORT "fehler stelle1: "
		SEVERITY warning;	

		WAIT;
		
	END PROCESS;
	
END behavioral;

------------------------------------------------------------------------------

CONFIGURATION bcd_stim_config OF bcd_stim IS
	FOR behavioral
	END FOR;
END bcd_stim_config;
		
