------------------------------------------------------------------------------
--
-- Filename:                ctr.vhd
-- Inhalt:                  synchroner, zyklischer Dualzaehler
--                          zwischen 0 und 3
--                          Positive Taktflankentriggerung
--
------------------------------------------------------------------------------
--
-- Autor:                   Gunther Lehmann
-- Letzte Aenderung:        07.02.94
--
------------------------------------------------------------------------------

ENTITY ctr IS
	PORT( takt: IN bit; cnt: OUT bit_vector ( 0 TO 1));
END ctr;

------------------------------------------------------------------------------

ARCHITECTURE behavioral OF ctr IS
BEGIN
    PROCESS (takt)
	VARIABLE count: integer RANGE 0 TO 3 := 0;
    BEGIN
		IF takt'event AND takt = '1' THEN
			IF count = 3 THEN
				count := 0;
			ELSE
				count := count + 1 ;
			END IF;

			CASE count IS
				WHEN 0 => cnt <= "00";
				WHEN 1 => cnt <= "01";
				WHEN 2 => cnt <= "10";
				WHEN 3 => cnt <= "11";
			END CASE;

		END IF;
    END PROCESS;
END behavioral;
